module.exports = (config) ->
	path = require 'path'
	log  = require "#{config.req.helpers}/log"
	test = require("#{config.req.helpers}/test")()

	# init node_modules
	# =================
	node_modules =
		dist:
			dir: path.join config.dist.rb.server.scripts.dir, 'node_modules'
			modules: {}
		src:
			dir: path.join config.rb.dir, 'node_modules'
			modules: {}

	# helpers
	# =======
	addModule = (module) ->
		for own k, v of node_modules
			v.modules[module] = path.join v.dir, module

	# modules
	# =======
	addModule 'express'
	addModule 'q'

	# add node_modules to config
	# ==========================
	config.node_modules = node_modules

	# logs
	# ====
	# log.json node_modules, 'node_modules ='
	# log.json config, 'config ='

	# tests
	# =====
	test.log 'true', config.node_modules, 'add node_modules to config'

	# return
	# ======
	config